"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DIStore {
    constructor() {
        this._instances = new Map();
    }
    static get instance() {
        if (!this._instance) {
            this._instance = new DIStore();
        }
        return this._instance;
    }
    createInstance(classType, id) {
        const instance = new classType();
        this._instances.set(id || instance, instance);
        return instance;
    }
    getInstance(idOrInstance) {
        return this._instances.get(idOrInstance);
    }
}
exports.DIStore = DIStore;
//# sourceMappingURL=DIStore.js.map