import { GQLField } from "./GQLField";
import { GraphQLArgument } from "graphql";
import { InstanceOf } from "../../../shared/InstanceOf";
import { InputFieldType } from "../../types/InputFieldType";
export declare class Arg<NameType = string> extends GQLField<GraphQLArgument> {
    protected _defaultValue: string | number | boolean;
    protected constructor(name: NameType, type: InputFieldType);
    static create<NameType = string>(name: keyof NameType, type: InputFieldType): Arg<keyof InstanceOf<NameType>>;
    build(): GraphQLArgument;
}
