import { Arg } from "./Arg";
import { ClassType } from "../../../shared/ClassType";
import { Removable } from "../../helpers/ArrayHelper";
import { InputFieldType } from "../../types/InputFieldType";
export declare class Args<T extends ClassType<any> = any> {
    private _args;
    private _classType?;
    protected constructor(classType?: T);
    static create<T extends ClassType<any>>(classType?: T): Args<T>;
    get args(): Arg<"M">[];
    setArgs(...args: Arg<keyof InstanceType<T>>[]): this;
    addArgs(...args: Arg<keyof InstanceType<T>>[]): this;
    addArg(arg: Arg<keyof InstanceType<T>>): any;
    addArg(name: keyof InstanceType<T>, type: InputFieldType): any;
    removeArgs(...args: Removable<Arg>): this;
    build(): import("graphql").GraphQLArgument[];
}
