"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Arg_1 = require("./Arg");
const ArrayHelper_1 = require("../../helpers/ArrayHelper");
class Args {
    constructor(classType) {
        this._args = [];
        this._classType = classType;
    }
    static create(classType) {
        return new Args(classType);
    }
    get args() {
        return this._args;
    }
    setArgs(...args) {
        this._args = args.filter((a) => a);
        return this;
    }
    addArgs(...args) {
        return this.setArgs(...this.args, ...args);
    }
    addArg(nameOrArg, type) {
        if (typeof nameOrArg === "string") {
            this.args.push(Arg_1.Arg.create(nameOrArg, type));
        }
        else {
            this.args.push(nameOrArg);
        }
        return this;
    }
    removeArgs(...args) {
        return this.setArgs(...ArrayHelper_1.ArrayHelper.remove(args, this._args));
    }
    build() {
        return this._args.map((a) => a.build());
    }
}
exports.Args = Args;
//# sourceMappingURL=Args.js.map