import { FieldType } from "../../types/FieldType";
import { GraphQLElement } from "../../types/GraphQLElement";
import { GraphQLField, GraphQLInputField } from "graphql";
export declare abstract class GQLField<BuiltType = any> extends GraphQLElement<BuiltType> {
    protected _type: FieldType;
    protected _deprecationReason: string;
    protected _description: string;
    get type(): FieldType;
    get description(): string;
    get deprecationReason(): string;
    abstract build(): GraphQLField<any, any, any> | GraphQLInputField;
    setType(type: FieldType): this;
    setDescription(description: string): this;
    setDeprecationReason(deprecationReason: string): this;
    constructor(name: string, type: FieldType);
}
