"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const GQLField_1 = require("./GQLField");
const TypeParser_1 = require("../../helpers/TypeParser");
class InputField extends GQLField_1.GQLField {
    constructor(name, type) {
        super(name, type);
    }
    static create(name, type) {
        return new InputField(name, type);
    }
    build() {
        const input = {
            name: this._name,
            type: TypeParser_1.TypeParser.parse(this._type),
            description: this._description,
            defaultValue: this._defaultValue,
            astNode: undefined,
            extensions: [],
        };
        this._built = input;
        return this.built;
    }
}
exports.InputField = InputField;
//# sourceMappingURL=InputField.js.map