import { GraphQLField, Source, GraphQLResolveInfo } from "graphql";
import { Field } from "./Field";
import { ResolveFunction } from "../../types/ResolveFunction";
import { FieldType } from "../../types/FieldType";
import { Arg } from "./Arg";
export declare class ObjectField extends Field<GraphQLField<any, any, any>> {
    private _args;
    private _resolve;
    private _middlewares;
    get args(): Arg<string>[];
    get resolve(): ResolveFunction<import("../../../shared/KeyValue").KeyValue>;
    static create(name: string, type: FieldType): any;
    addMiddlewares(...middlewares: ResolveFunction[]): this;
    setResolve<ArgsType>(resolve: ResolveFunction<ArgsType>, ...args: (Arg | Arg[])[]): this;
    build(): GraphQLField<any, any, any>;
    resolveField(source: Source, args: any, context: any, infos: GraphQLResolveInfo): Promise<any>;
}
