import { GQLField } from "../fields/GQLField";
import { ObjectType } from "./ObjectType";
import { InterfaceType } from "./InterfaceType";
import { InputType } from "./InputType";
import { InputField } from "../fields/InputField";
import { Field } from "../fields/Field";
import { ComposedType } from "./composed/ComposedType";
import { Removable } from "../../helpers/ArrayHelper";
export declare abstract class GQLType<BuiltType = any> extends ComposedType<BuiltType> {
    protected _fields: GQLField[];
    protected _hidden: boolean;
    protected _extension?: GQLType;
    get fields(): GQLField<any>[];
    get hidden(): boolean;
    constructor(name?: string);
    setFields(...fields: GQLField[]): this;
    addFields(...fields: GQLField[]): this;
    removeFields(...fields: Removable<GQLField>): this;
    setExtension(extension: GQLType): this;
    setHidden(hidden: boolean): this;
    partial(): this;
    required(): this;
    protected preBuild(): this;
    protected toConfigMap<ReturnType>(arr: {
        name: string;
        build(): any;
    }[]): ReturnType;
    protected applyFieldsTransformation<FieldType extends InputField | Field>(cb: (field: FieldType) => void): void[];
    abstract convert(to: typeof InterfaceType | typeof InputType): InputType | ObjectType | InterfaceType;
    abstract copy(): InputType | ObjectType | InterfaceType;
    abstract transformFields(cb: (field: InputField | Field) => void): any;
}
