"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const GQLType_1 = require("./GQLType");
const TypeConverter_1 = require("../../helpers/TypeConverter");
class InputType extends GQLType_1.GQLType {
    get fields() {
        return this._fields;
    }
    static create(name) {
        return new InputType(name);
    }
    build() {
        this.preBuild();
        const input = {
            name: this._name,
            description: this._description,
            getFields: () => {
                return this.toConfigMap(this.fields);
            },
            extensions: [],
            astNode: undefined,
            extensionASTNodes: undefined,
            toConfig: undefined,
            toJSON: undefined,
            inspect: undefined,
        };
        this._built = input;
        return input;
    }
    convert(to) {
        return TypeConverter_1.TypeConverter.convert(this, to);
    }
    copy() {
        return InputType.create(this.name)
            .setDescription(this._description)
            .setHidden(this._hidden)
            .setExtension(this._extension)
            .addFields(...this._fields);
    }
    transformFields(cb) {
        this.applyFieldsTransformation(cb);
        return this;
    }
}
exports.InputType = InputType;
//# sourceMappingURL=InputType.js.map