import { GQLType } from "./GQLType";
import { GraphQLInterfaceType, GraphQLTypeResolver } from "graphql";
import { Field } from "../fields/Field";
import { ConversionType } from "../../helpers/TypeConverter";
import { TypeResolvable } from "../../types/TypeResolvable";
import { KeyValue } from "../../../shared/KeyValue";
export declare class InterfaceType extends GQLType<GraphQLInterfaceType> implements TypeResolvable {
    protected _typeResolver: GraphQLTypeResolver<any, any>;
    protected _fields: Field[];
    get fields(): Field[];
    protected constructor(name: string);
    static create(name: string): InterfaceType;
    setTypeResolver<TSource = any, TContext = any>(typeResolver: GraphQLTypeResolver<TSource, TContext>): this;
    build(): GraphQLInterfaceType;
    convert<Target extends ConversionType>(to: Target): import("../../../shared/InstanceOf").InstanceOf<Target>;
    copy(): InterfaceType;
    transformFields(cb: (field: Field) => void): this;
    defaultTypeResolver(obj: KeyValue): any;
}
