import { GQLType } from "./GQLType";
import { Field } from "../fields/Field";
import { GraphQLObjectType } from "graphql";
import { InterfaceType } from "./InterfaceType";
import { ConversionType } from "../../helpers/TypeConverter";
export declare class ObjectType extends GQLType<GraphQLObjectType> {
    protected _fields: Field[];
    private _implementations;
    get fields(): Field[];
    get implementations(): InterfaceType[];
    setImplementations(...implementations: InterfaceType[]): this;
    addImplementations(...implementations: InterfaceType[]): this;
    removeImplementation(type: InterfaceType): this;
    static create(name: string): ObjectType;
    build(): GraphQLObjectType;
    convert<Target extends ConversionType>(to: Target): import("../../../shared/InstanceOf").InstanceOf<Target>;
    copy(): ObjectType;
    transformFields(cb: (field: Field) => void): this;
}
