import { GraphQLUnionType, GraphQLTypeResolver } from "graphql";
import { ComposedType } from "./ComposedType";
import { KeyValue } from "../../../../shared/KeyValue";
import { TypeResolvable } from "../../../types/TypeResolvable";
import { ObjectType } from "../ObjectType";
import { Removable } from "../../../helpers/ArrayHelper";
export declare class UnionType extends ComposedType<GraphQLUnionType> implements TypeResolvable {
    private _types;
    private _typeResolver;
    protected constructor(name: string);
    static create(name: string): UnionType;
    setTypeResolver<TSource = any, TContext = any>(typeResolver: GraphQLTypeResolver<TSource, TContext>): this;
    setTypes(...types: ObjectType[]): this;
    addTypes(...types: ObjectType[]): this;
    removeTypes(...types: Removable<ObjectType>): this;
    copy(): UnionType;
    build(): GraphQLUnionType;
    defaultTypeResolver(obj: KeyValue): any;
}
