"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const GraphQLElement_1 = require("../../../../types/GraphQLElement");
class EnumValue extends GraphQLElement_1.GraphQLElement {
    constructor(name, value) {
        super(name);
        this.setType(value);
    }
    get value() {
        return this._value;
    }
    setType(value) {
        this._value = value;
    }
    static create(name, value) {
        return new EnumValue(name, value);
    }
    build() {
        this._built = {
            name: this.name,
            value: this.value,
            deprecationReason: this._deprecationReason,
            description: this._description,
            isDeprecated: !!this._deprecationReason,
            extensions: [],
        };
        return { ...this._built };
    }
}
exports.EnumValue = EnumValue;
//# sourceMappingURL=EnumValue.js.map