"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const InputType_1 = require("../defintion/types/InputType");
const Field_1 = require("../defintion/fields/Field");
const InputField_1 = require("../defintion/fields/InputField");
class TypeConverter {
    static convert(typeDefinition, target) {
        const newTypeDef = target.create(typeDefinition.name);
        let newFields;
        // Input => Interface / Object
        if (this instanceof InputType_1.InputType && target !== InputType_1.InputType) {
            const inputFields = this.fields.map((f) => {
                return Field_1.Field.create(f.name, f.type)
                    .setDescription(f.description)
                    .setDeprecationReason(f.deprecationReason);
            });
            newFields = inputFields;
        }
        // Object / Interface => Input
        else if (!(this instanceof InputType_1.InputType) && target === InputType_1.InputType) {
            const objectFields = typeDefinition.fields.reduce((prev, f) => {
                if (!f.resolve) {
                    prev.push(InputField_1.InputField.create(f.name, f.type)
                        .setDescription(f.description)
                        .setDeprecationReason(f.deprecationReason));
                }
                return prev;
            }, []);
            newFields = objectFields;
        }
        // Object / Interface => Object / Interface OR Input => Input
        else {
            newFields = typeDefinition.fields;
        }
        newTypeDef.addFields(...newFields);
        return newTypeDef;
    }
}
exports.TypeConverter = TypeConverter;
//# sourceMappingURL=TypeConverter.js.map