"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
const NotNullable_1 = require("../defintion/modifiers/NotNullable");
const GQLType_1 = require("../defintion/types/GQLType");
const DateTime_1 = require("../scalars/DateTime");
class TypeParser {
    static parse(type) {
        let finalType;
        if (Array.isArray(type)) {
            finalType = this.parse(type[0]);
            finalType = graphql_1.GraphQLList(finalType);
        }
        if (type instanceof GQLType_1.GQLType) {
            finalType = type.built;
        }
        switch (type) {
            case String:
                finalType = graphql_1.GraphQLString;
                break;
            case Number:
                finalType = graphql_1.GraphQLFloat;
                break;
            case Boolean:
                finalType = graphql_1.GraphQLBoolean;
            case Date:
                finalType = DateTime_1.DateTime;
                break;
        }
        if (type instanceof NotNullable_1.NotNullableType) {
            finalType = graphql_1.GraphQLNonNull(this.parse(type.type));
        }
        return finalType;
    }
}
exports.TypeParser = TypeParser;
//# sourceMappingURL=TypeParser.js.map