import { ObjectType } from "../graphql/defintion/types/ObjectType";
import { InterfaceType } from "../graphql/defintion/types/InterfaceType";
import { Field } from "../graphql/defintion/fields/Field";
import { ComposedType } from "../graphql/defintion/types/composed/ComposedType";
import { InputField } from "../graphql/defintion/fields/InputField";
import { InputType } from "../graphql/defintion/types/InputType";
import { InstanceOf } from "../shared/InstanceOf";
import { GQLField } from "../graphql/defintion/fields/GQLField";
import { GQLType } from "../graphql/defintion/types/GQLType";
import { Middleware } from "../graphql/defintion/middlewares/Middleware";
export declare type TranformableTypes = typeof ObjectType | typeof InterfaceType | typeof InputType | typeof GQLType;
export declare class Wrapper {
    protected _types: ComposedType[];
    get types(): ComposedType<any>[];
    protected constructor(...types: ComposedType[]);
    static create(...types: ComposedType[]): Wrapper;
    addTypes(...types: ComposedType[]): this;
    addMiddlewares(...middlewares: Middleware[]): void;
    transform<T extends TranformableTypes>(toTransform: T, cb: (type: InstanceOf<T>) => void): void;
    transformFields<T extends typeof Field | typeof InputField | typeof GQLField>(fieldType: T, cb: (field: InstanceOf<T>) => void): void;
}
